#-*- coding: utf-8 -*-
#!python3

import sys
from PIL import Image

# https://gbatemp.net/threads/phantom-kingdom-portable-english-translation.365313/page-5#post-5041911
def UnSwizzle(Buf, Width, Height):
    Swizzled = Buf[:]
    rowblocks = Width // 16
    for y in range(Height):
        for x in range(Width):
            blockx = x // 16
            blocky = y // 8
            block_index  = blockx + (blocky * rowblocks)
            block_address = block_index * 16 * 8
            Buf[x + (y * Width)] = Swizzled[block_address + (x - blockx * 16) + ((y - blocky * 8) * 16)]

if len(sys.argv) > 1:
    filename = sys.argv[1]
else:
    sys.exit(1)

with open(filename, "rb") as f:
    tex = f.read()

if tex[0x19] == 4:
    palette_colors = 16
elif tex[0x19] == 8:
    palette_colors = 256
width = tex[0x0C] + tex[0x0D] * 256
height = tex[0x0E] + tex[0x0F] * 256
background = (0, 0, 0, 255)

palette = []
for i in range(palette_colors):
    palette.append(tuple(tex[i*4+32:i*4+32+4]))
img_bytes = list(tex[32+palette_colors*4:])

image = Image.new("RGBA", (width, height), background)
pixels = image.load()

i = 0
for y in range(height):
    for x in range(width):
        if palette_colors == 16:
            if i % 2 == 0:
                pixels[x, y] = palette[(img_bytes[i // 2] & 0xF0)>>4]
            else:
                pixels[x, y] = palette[(img_bytes[i // 2] & 0x0F)>>0]
        elif palette_colors == 256:
            pixels[x, y] = palette[img_bytes[i]]
        i += 1

pixels2 = [pixels[i % width, i / width] for i in range(width * height)]
UnSwizzle(pixels2, width, height)
i = 0
for y in range(height):
    for x in range(width):
        pixels[x, y] = pixels2[i]
        i += 1

image.save("{}.png".format(filename))